#!/bin/bash
# http://wxpython.org/
#
# til <rob DOT til DOT freedman AT googlemail DOT com>
REPO=http://zenwalk.pinguix.com/user-accounts/tilderb
CWD=`pwd`
set -e -u -x

name=wxgtk
version=2.8.11.0

build=66.1
arch=${arch:-i686}
#cpu=pentium-m
cpu=${cpu:-i686}

TMP=${TMP:-$CWD/tmp}
pkgname=$name-$version
package=$pkgname-$arch-$build

SRC_URL=http://downloads.sourceforge.net/wxpython
SRC_PKG=wxPython-src-$version.tar.bz2

PKG_DEP="atk,cairo,cxxlibs|gcc-g++,expat,fontconfig,freetype,gcc,glib2,gtk+2,libICE,libSM,libX11,libXau,libXcomposite,libXcursor,libXdamage,libXdmcp,libXext,libXfixes,libXi,libXinerama,libXrandr,libXrender,libXxf86vm,libjpeg,libpng,libtiff,libxcb,mesa,pango,pixman,sdl,svgalib,util-linux-ng,zlib"
PKG_SRC="$REPO/extra/l/wxgtk/build-wxgtk.sh
$REPO/extra/l/wxgtk/glibGSocket.patch
$SRC_URL/$SRC_PKG"

# check source exists
for url in $PKG_SRC;do [ ! -e ${url##*/} ] && wget -N -c $url; done

PKG=$TMP/$package
SRC=$TMP/$pkgname

[ -d $SRC ] && rm -fr $SRC
[ -d $PKG ] && rm -fr $PKG

# prepare build directory
mkdir -p $SRC $PKG/{install,usr/{src,doc}/$pkgname}

tar xf $CWD/$SRC_PKG --strip-components=1 -C $SRC
cd $SRC

./configure --help
# http://trac.wxwidgets.org/ticket/10883
#patch -Np1 -i $CWD/glibGSocket.patch 

CFLAGS="-O2 -march=$arch -mtune=$cpu" \
CXXFLAGS="-O2 -march=$arch -mtune=$cpu" \
	./configure \
	--prefix=/usr -libdir=/usr/lib \
	--with-opengl --enable-unicode \
	--enable-graphics_ctx  --with-sdl \
	--enable-optimize

make
make -C locale allmo
make install DESTDIR=$PKG

( cd contrib
  make || exit
  make install DESTDIR=$PKG || exit
)

# make the wx-config symlink relative
( cd $PKG/usr/bin
  TARGET=$(readlink wx-config | sed 's|.*usr|\.\.|')
  rm -f wx-config
  ln -sf $TARGET wx-config
)
# copy docs
cp -ar docs/gtk docs/*.txt $PKG/usr/doc/$pkgname

# strip symbols
find $PKG | xargs -r file | grep "executable" | grep ELF | cut -f 1 -d : | xargs -r strip --strip-unneeded
find $PKG | xargs -r file | grep "shared object" | grep ELF | cut -f 1 -d : | xargs -r strip --strip-unneeded
find $PKG | xargs -r file | grep "current ar archive" | cut -f 1 -d : | xargs -r strip -g

cat << EOC > ${PKG}/install/slack-desc
#    |-----handy-ruler------------------------------------------------------|
wxgtk: wxgtk (the wxWidgets toolkit for GTK)
wxgtk:
wxgtk: wxWidgets lets developers create applications for Win32, Mac OS X,
wxgtk: GTK+, X11, Motif, WinCE, and more using one codebase.
wxgtk: This package contains the wxwidgets built with the GTK+2.0 toolkit.
wxgtk:
EOC
cp $CWD/build-wxgtk.sh $PKG/usr/src/$pkgname

cd $PKG
rootworker=$(which fakeroot 2>/dev/null) || { [ "$UID" != "0" ] && { echo "need fakeroot"; exit 1; } }
$rootworker /sbin/makepkg -l y -c n $CWD/$package.txz

cd $CWD
echo -n $PKG_DEP >$package.dep
#depfinder $PKG
echo "$PKG_SRC" >$package.src
md5sum $package.txz >$package.md5
